/* EEPROM Write routines. Based on Microchip Routines. Again borrowed
   from the Beginners guide to the Microchip PIC Version 2. Pages 78-79.
   This routine is time critical and can take 10 miliseconds per byte.

   Version 1.0
   21st July 1998
   By Ian Stedman
*/

ee_write( addr, data )
char addr;
char data;
{
#asm

    movf    addr,W      ; Copy the address of ram to write to, to W.
    movw    EEADR       ; Move value to Address register.
    movf    data,W      ; Now move the data to W.
    movw    EEDATA      ; Move data to the data register.
    bsf     STATUS,RP0  ; Set Page 1 Registers.
    bsf     EECON1,WREN ; Write Enable.
    movlw   55h         ; Start to enable the write.
    movw    EECON2
    movlw   AAh
    movw    EECON2      ; Need to follow this sequence exactly.
    bsf     EECON1,WR   ; Now write the actual data.
w1  btfsc   EECON1,WR   ; Wait for write to finish.
    goto    w1
    bcf     STATUS,RP0  ; Return register page to 0.
#endasm
}
