/* IO Port routines. There are routines to Set the ports and to Read/Write
   to them. Implemented without the use of the TRIS instruction.
   Version 1.0
   21st July 1998.
   By Ian Stedman
*/

SetPortA( value )
char value;
{
#asm
        bsf     STATUS,RP0   ; Set Page 1 of memory/registers.
        movw    value,W      ; Move port data to W
        movw    TRISA        ; Copy it to the Tri-State register.
        bcf     STATUS,RP0   ; Reset page 0 of registers and Done!
#endasm
}


SetPortB( value )
char value;
{
#asm
        bsf     STATUS,RP0   ; Set Page 1 of memory/registers.
        movf    value,W      ; Move port data to W
        movw    TRISB        ; Copy it to the Tri-State register.
        bcf     STATUS,RP0   ; Reset Page 0 of registers and done!
#endasm
}

/* read IO port value */

RdPortA()
{
#asm
        movf    PORTA,W      ; Read PortA into W.
#endasm
}


RdPortB ()
{
#asm
        movf    PORTB,W     ; Read PortB into W.
#endasm
}

/* Write values to I/O ports as necessary */

WrPortA( value )
char value;
{
#asm
        movf value,W    ; Copy data to W.
        movw PORTA      ; Data to PORTA.
#endasm
}


WrPortB( value )
char value;
{
#asm
        movf value,W    ; Copy data to W.
        movw PORTB      ; Data to PORTB.
#endasm
}


